/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml13.behavioral_elements.common_behavior;

import org.eclipse.emf.common.util.EList;

import fr.obeo.acceleo.uml13.foundation.core.ModelElement;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Stimulus</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Stimulus#getArgument
 * <em>Argument</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Stimulus#getSender
 * <em>Sender</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Stimulus#getReceiver
 * <em>Receiver</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Stimulus#getCommunicationLink
 * <em>Communication Link</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Stimulus#getDispatchAction
 * <em>Dispatch Action</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Common_behaviorPackage#getStimulus()
 * @model
 * @generated
 */
public interface Stimulus extends ModelElement {
	/**
	 * Returns the value of the '<em><b>Argument</b></em>' reference list. The
	 * list contents are of type
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Instance}
	 * . It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Instance#getStimulus1
	 * <em>Stimulus1</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Argument</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Argument</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Common_behaviorPackage#getStimulus_Argument()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Instance#getStimulus1
	 * @model type=
	 *        "fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Instance"
	 *        opposite="stimulus1"
	 * @generated
	 */
	EList getArgument();

	/**
	 * Returns the value of the '<em><b>Sender</b></em>' reference. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Instance#getStimulus3
	 * <em>Stimulus3</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Sender</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Sender</em>' reference.
	 * @see #setSender(Instance)
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Common_behaviorPackage#getStimulus_Sender()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Instance#getStimulus3
	 * @model opposite="stimulus3" required="true"
	 * @generated
	 */
	Instance getSender();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Stimulus#getSender
	 * <em>Sender</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Sender</em>' reference.
	 * @see #getSender()
	 * @generated
	 */
	void setSender(Instance value);

	/**
	 * Returns the value of the '<em><b>Receiver</b></em>' reference. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Instance#getStimulus2
	 * <em>Stimulus2</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Receiver</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Receiver</em>' reference.
	 * @see #setReceiver(Instance)
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Common_behaviorPackage#getStimulus_Receiver()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Instance#getStimulus2
	 * @model opposite="stimulus2" required="true"
	 * @generated
	 */
	Instance getReceiver();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Stimulus#getReceiver
	 * <em>Receiver</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Receiver</em>' reference.
	 * @see #getReceiver()
	 * @generated
	 */
	void setReceiver(Instance value);

	/**
	 * Returns the value of the '<em><b>Communication Link</b></em>' reference.
	 * It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Link#getStimulus
	 * <em>Stimulus</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Communication Link</em>' reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Communication Link</em>' reference.
	 * @see #setCommunicationLink(Link)
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Common_behaviorPackage#getStimulus_CommunicationLink()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Link#getStimulus
	 * @model opposite="stimulus"
	 * @generated
	 */
	Link getCommunicationLink();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Stimulus#getCommunicationLink
	 * <em>Communication Link</em>}' reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Communication Link</em>' reference.
	 * @see #getCommunicationLink()
	 * @generated
	 */
	void setCommunicationLink(Link value);

	/**
	 * Returns the value of the '<em><b>Dispatch Action</b></em>' reference. It
	 * is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Action#getStimulus
	 * <em>Stimulus</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dispatch Action</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Dispatch Action</em>' reference.
	 * @see #setDispatchAction(Action)
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Common_behaviorPackage#getStimulus_DispatchAction()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Action#getStimulus
	 * @model opposite="stimulus" required="true"
	 * @generated
	 */
	Action getDispatchAction();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Stimulus#getDispatchAction
	 * <em>Dispatch Action</em>}' reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Dispatch Action</em>' reference.
	 * @see #getDispatchAction()
	 * @generated
	 */
	void setDispatchAction(Action value);

} // Stimulus
