/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EObject;

import fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.ActionState;
import fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.ActivityGraph;
import fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.Activity_graphsPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.CallState;
import fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.ClassifierInState;
import fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.ObjectFlowState;
import fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.Partition;
import fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.SubactivityState;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.CompositeState;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SimpleState;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.State;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StateMachine;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StateVertex;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SubmachineState;
import fr.obeo.acceleo.uml14.foundation.core.Classifier;
import fr.obeo.acceleo.uml14.foundation.core.Element;
import fr.obeo.acceleo.uml14.foundation.core.GeneralizableElement;
import fr.obeo.acceleo.uml14.foundation.core.ModelElement;
import fr.obeo.acceleo.uml14.foundation.core.Namespace;

/**
 * <!-- begin-user-doc --> The <b>Adapter Factory</b> for the model. It provides
 * an adapter <code>createXXX</code> method for each class of the model. <!--
 * end-user-doc -->
 * 
 * @see fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.Activity_graphsPackage
 * @generated
 */
public class Activity_graphsAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected static Activity_graphsPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public Activity_graphsAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = Activity_graphsPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc --> This implementation returns <code>true</code> if
	 * the object is either the model's package or is an instance object of the
	 * model. <!-- end-user-doc -->
	 * 
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject) object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch the delegates to the <code>createXXX</code> methods. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected Activity_graphsSwitch modelSwitch = new Activity_graphsSwitch() {
		public Object caseActivityGraph(ActivityGraph object) {
			return createActivityGraphAdapter();
		}

		public Object casePartition(Partition object) {
			return createPartitionAdapter();
		}

		public Object caseSubactivityState(SubactivityState object) {
			return createSubactivityStateAdapter();
		}

		public Object caseActionState(ActionState object) {
			return createActionStateAdapter();
		}

		public Object caseCallState(CallState object) {
			return createCallStateAdapter();
		}

		public Object caseObjectFlowState(ObjectFlowState object) {
			return createObjectFlowStateAdapter();
		}

		public Object caseClassifierInState(ClassifierInState object) {
			return createClassifierInStateAdapter();
		}

		public Object caseElement(Element object) {
			return createElementAdapter();
		}

		public Object caseModelElement(ModelElement object) {
			return createModelElementAdapter();
		}

		public Object caseStateMachine(StateMachine object) {
			return createStateMachineAdapter();
		}

		public Object caseStateVertex(StateVertex object) {
			return createStateVertexAdapter();
		}

		public Object caseState(State object) {
			return createStateAdapter();
		}

		public Object caseCompositeState(CompositeState object) {
			return createCompositeStateAdapter();
		}

		public Object caseSubmachineState(SubmachineState object) {
			return createSubmachineStateAdapter();
		}

		public Object caseSimpleState(SimpleState object) {
			return createSimpleStateAdapter();
		}

		public Object caseGeneralizableElement(GeneralizableElement object) {
			return createGeneralizableElementAdapter();
		}

		public Object caseNamespace(Namespace object) {
			return createNamespaceAdapter();
		}

		public Object caseClassifier(Classifier object) {
			return createClassifierAdapter();
		}

		public Object defaultCase(EObject object) {
			return createEObjectAdapter();
		}
	};

	/**
	 * Creates an adapter for the <code>target</code>. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @param target
	 *            the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	public Adapter createAdapter(Notifier target) {
		return (Adapter) modelSwitch.doSwitch((EObject) target);
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.ActivityGraph
	 * <em>Activity Graph</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.ActivityGraph
	 * @generated
	 */
	public Adapter createActivityGraphAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.Partition
	 * <em>Partition</em>}'. <!-- begin-user-doc --> This default implementation
	 * returns null so that we can easily ignore cases; it's useful to ignore a
	 * case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.Partition
	 * @generated
	 */
	public Adapter createPartitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.SubactivityState
	 * <em>Subactivity State</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.SubactivityState
	 * @generated
	 */
	public Adapter createSubactivityStateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.ActionState
	 * <em>Action State</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.ActionState
	 * @generated
	 */
	public Adapter createActionStateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.CallState
	 * <em>Call State</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.CallState
	 * @generated
	 */
	public Adapter createCallStateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.ObjectFlowState
	 * <em>Object Flow State</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.ObjectFlowState
	 * @generated
	 */
	public Adapter createObjectFlowStateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.ClassifierInState
	 * <em>Classifier In State</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.ClassifierInState
	 * @generated
	 */
	public Adapter createClassifierInStateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Element <em>Element</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Element
	 * @generated
	 */
	public Adapter createElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.ModelElement
	 * <em>Model Element</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.ModelElement
	 * @generated
	 */
	public Adapter createModelElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StateMachine
	 * <em>State Machine</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StateMachine
	 * @generated
	 */
	public Adapter createStateMachineAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StateVertex
	 * <em>State Vertex</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StateVertex
	 * @generated
	 */
	public Adapter createStateVertexAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.State
	 * <em>State</em>}'. <!-- begin-user-doc --> This default implementation
	 * returns null so that we can easily ignore cases; it's useful to ignore a
	 * case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.State
	 * @generated
	 */
	public Adapter createStateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.CompositeState
	 * <em>Composite State</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.CompositeState
	 * @generated
	 */
	public Adapter createCompositeStateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SubmachineState
	 * <em>Submachine State</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SubmachineState
	 * @generated
	 */
	public Adapter createSubmachineStateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SimpleState
	 * <em>Simple State</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SimpleState
	 * @generated
	 */
	public Adapter createSimpleStateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.GeneralizableElement
	 * <em>Generalizable Element</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.GeneralizableElement
	 * @generated
	 */
	public Adapter createGeneralizableElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Namespace
	 * <em>Namespace</em>}'. <!-- begin-user-doc --> This default implementation
	 * returns null so that we can easily ignore cases; it's useful to ignore a
	 * case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Namespace
	 * @generated
	 */
	public Adapter createNamespaceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Classifier
	 * <em>Classifier</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Classifier
	 * @generated
	 */
	public Adapter createClassifierAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case. <!-- begin-user-doc --> This
	 * default implementation returns null. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} // Activity_graphsAdapterFactory
