/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.behavioral_elements.collaborations;

import org.eclipse.emf.common.util.EList;

import fr.obeo.acceleo.uml14.foundation.core.Classifier;
import fr.obeo.acceleo.uml14.foundation.data_types.Multiplicity;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Classifier Role</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.ClassifierRole#getMultiplicity
 * <em>Multiplicity</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.ClassifierRole#getMessage
 * <em>Message</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.ClassifierRole#getAvailableContents
 * <em>Available Contents</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.ClassifierRole#getConformingInstance
 * <em>Conforming Instance</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.obeo.acceleo.uml14.behavioral_elements.collaborations.CollaborationsPackage#getClassifierRole()
 * @model
 * @generated
 */
public interface ClassifierRole extends Classifier {
	/**
	 * Returns the value of the '<em><b>Multiplicity</b></em>' containment
	 * reference. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Multiplicity</em>' containment reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Multiplicity</em>' containment reference.
	 * @see #setMultiplicity(Multiplicity)
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.collaborations.CollaborationsPackage#getClassifierRole_Multiplicity()
	 * @model containment="true"
	 * @generated
	 */
	Multiplicity getMultiplicity();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.ClassifierRole#getMultiplicity
	 * <em>Multiplicity</em>}' containment reference. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Multiplicity</em>' containment
	 *            reference.
	 * @see #getMultiplicity()
	 * @generated
	 */
	void setMultiplicity(Multiplicity value);

	/**
	 * Returns the value of the '<em><b>Message</b></em>' reference list. The
	 * list contents are of type
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.Message}.
	 * It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.Message#getSender
	 * <em>Sender</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Message</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Message</em>' reference list.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.collaborations.CollaborationsPackage#getClassifierRole_Message()
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.collaborations.Message#getSender
	 * @model 
	 *        type="fr.obeo.acceleo.uml14.behavioral_elements.collaborations.Message"
	 *        opposite="sender"
	 * @generated
	 */
	EList getMessage();

	/**
	 * Returns the value of the '<em><b>Available Contents</b></em>' reference
	 * list. The list contents are of type
	 * {@link fr.obeo.acceleo.uml14.foundation.core.ModelElement}. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.ModelElement#getClassifierRole
	 * <em>Classifier Role</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Available Contents</em>' reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Available Contents</em>' reference list.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.collaborations.CollaborationsPackage#getClassifierRole_AvailableContents()
	 * @see fr.obeo.acceleo.uml14.foundation.core.ModelElement#getClassifierRole
	 * @model type="fr.obeo.acceleo.uml14.foundation.core.ModelElement"
	 *        opposite="classifierRole"
	 * @generated
	 */
	EList getAvailableContents();

	/**
	 * Returns the value of the '<em><b>Conforming Instance</b></em>' reference
	 * list. The list contents are of type
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Instance}
	 * . It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Instance#getPlayedRole
	 * <em>Played Role</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Conforming Instance</em>' reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Conforming Instance</em>' reference list.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.collaborations.CollaborationsPackage#getClassifierRole_ConformingInstance()
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Instance#getPlayedRole
	 * @model type=
	 *        "fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Instance"
	 *        opposite="playedRole"
	 * @generated
	 */
	EList getConformingInstance();

} // ClassifierRole
