/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.CollaborationInstanceSet;
import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.CollaborationsPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.Interaction;
import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.InteractionInstanceSet;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Common_behaviorPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Stimulus;
import fr.obeo.acceleo.uml14.foundation.core.CorePackage;
import fr.obeo.acceleo.uml14.foundation.core.Namespace;
import fr.obeo.acceleo.uml14.foundation.core.TemplateParameter;
import fr.obeo.acceleo.uml14.foundation.core.impl.ModelElementImpl;
import fr.obeo.acceleo.uml14.foundation.data_types.VisibilityKind;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Interaction Instance Set</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.InteractionInstanceSetImpl#getContext
 * <em>Context</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.InteractionInstanceSetImpl#getInteraction
 * <em>Interaction</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.InteractionInstanceSetImpl#getParticipatingStimulus
 * <em>Participating Stimulus</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class InteractionInstanceSetImpl extends ModelElementImpl implements InteractionInstanceSet {
	/**
	 * The cached value of the '{@link #getInteraction() <em>Interaction</em>}'
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getInteraction()
	 * @generated
	 * @ordered
	 */
	protected Interaction interaction = null;

	/**
	 * The cached value of the '{@link #getParticipatingStimulus()
	 * <em>Participating Stimulus</em>}' reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #getParticipatingStimulus()
	 * @generated
	 * @ordered
	 */
	protected EList participatingStimulus = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected InteractionInstanceSetImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return CollaborationsPackage.eINSTANCE.getInteractionInstanceSet();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public CollaborationInstanceSet getContext() {
		if (eContainerFeatureID != CollaborationsPackage.INTERACTION_INSTANCE_SET__CONTEXT)
			return null;
		return (CollaborationInstanceSet) eContainer;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setContext(CollaborationInstanceSet newContext) {
		if (newContext != eContainer || (eContainerFeatureID != CollaborationsPackage.INTERACTION_INSTANCE_SET__CONTEXT && newContext != null)) {
			if (EcoreUtil.isAncestor(this, newContext))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newContext != null)
				msgs = ((InternalEObject) newContext).eInverseAdd(this, CollaborationsPackage.COLLABORATION_INSTANCE_SET__INTERACTION_INSTANCE_SET, CollaborationInstanceSet.class, msgs);
			msgs = eBasicSetContainer((InternalEObject) newContext, CollaborationsPackage.INTERACTION_INSTANCE_SET__CONTEXT, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CollaborationsPackage.INTERACTION_INSTANCE_SET__CONTEXT, newContext, newContext));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Interaction getInteraction() {
		if (interaction != null && interaction.eIsProxy()) {
			Interaction oldInteraction = interaction;
			interaction = (Interaction) eResolveProxy((InternalEObject) interaction);
			if (interaction != oldInteraction) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CollaborationsPackage.INTERACTION_INSTANCE_SET__INTERACTION, oldInteraction, interaction));
			}
		}
		return interaction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Interaction basicGetInteraction() {
		return interaction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetInteraction(Interaction newInteraction, NotificationChain msgs) {
		Interaction oldInteraction = interaction;
		interaction = newInteraction;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CollaborationsPackage.INTERACTION_INSTANCE_SET__INTERACTION, oldInteraction, newInteraction);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setInteraction(Interaction newInteraction) {
		if (newInteraction != interaction) {
			NotificationChain msgs = null;
			if (interaction != null)
				msgs = ((InternalEObject) interaction).eInverseRemove(this, CollaborationsPackage.INTERACTION__INTERACTION_INSTANCE_SET, Interaction.class, msgs);
			if (newInteraction != null)
				msgs = ((InternalEObject) newInteraction).eInverseAdd(this, CollaborationsPackage.INTERACTION__INTERACTION_INSTANCE_SET, Interaction.class, msgs);
			msgs = basicSetInteraction(newInteraction, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CollaborationsPackage.INTERACTION_INSTANCE_SET__INTERACTION, newInteraction, newInteraction));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getParticipatingStimulus() {
		if (participatingStimulus == null) {
			participatingStimulus = new EObjectWithInverseResolvingEList.ManyInverse(Stimulus.class, this, CollaborationsPackage.INTERACTION_INSTANCE_SET__PARTICIPATING_STIMULUS,
					Common_behaviorPackage.STIMULUS__INTERACTION_INSTANCE_SET);
		}
		return participatingStimulus;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CollaborationsPackage.INTERACTION_INSTANCE_SET__NAMESPACE, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__PARAMETER_TEMPLATE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CollaborationsPackage.INTERACTION_INSTANCE_SET__PARAMETER_TEMPLATE, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__CONTEXT:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CollaborationsPackage.INTERACTION_INSTANCE_SET__CONTEXT, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__INTERACTION:
				if (interaction != null)
					msgs = ((InternalEObject) interaction).eInverseRemove(this, CollaborationsPackage.INTERACTION__INTERACTION_INSTANCE_SET, Interaction.class, msgs);
				return basicSetInteraction((Interaction) otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__PARTICIPATING_STIMULUS:
				return ((InternalEList) getParticipatingStimulus()).basicAdd(otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__NAMESPACE:
				return eBasicSetContainer(null, CollaborationsPackage.INTERACTION_INSTANCE_SET__NAMESPACE, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__PARAMETER_TEMPLATE:
				return eBasicSetContainer(null, CollaborationsPackage.INTERACTION_INSTANCE_SET__PARAMETER_TEMPLATE, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__CONTEXT:
				return eBasicSetContainer(null, CollaborationsPackage.INTERACTION_INSTANCE_SET__CONTEXT, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__INTERACTION:
				return basicSetInteraction(null, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__PARTICIPATING_STIMULUS:
				return ((InternalEList) getParticipatingStimulus()).basicRemove(otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__PARAMETER_TEMPLATE:
				return eContainer.eInverseRemove(this, CorePackage.TEMPLATE_PARAMETER__PARAMETER, TemplateParameter.class, msgs);
			case CollaborationsPackage.INTERACTION_INSTANCE_SET__CONTEXT:
				return eContainer.eInverseRemove(this, CollaborationsPackage.COLLABORATION_INSTANCE_SET__INTERACTION_INSTANCE_SET, CollaborationInstanceSet.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__NAME:
			return getName();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__VISIBILITY:
			return getVisibility();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__NAMESPACE:
			return getNamespace();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__CLIENT_DEPENDENCY:
			return getClientDependency();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__CONSTRAINT:
			return getConstraint();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__PRESENTATION:
			return getPresentation();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__TARGET_FLOW:
			return getTargetFlow();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__SOURCE_FLOW:
			return getSourceFlow();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__DEFAULTED_PARAMETER:
			return getDefaultedParameter();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__COMMENT:
			return getComment();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__ELEMENT_RESIDENCE:
			return getElementResidence();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__PARAMETER_TEMPLATE:
			return getParameterTemplate();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__STEREOTYPE:
			return getStereotype();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__TAGGED_VALUE:
			return getTaggedValue();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__REFERENCE_TAG:
			return getReferenceTag();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__TEMPLATE_ARGUMENT:
			return getTemplateArgument();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__BEHAVIOR:
			return getBehavior();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__CLASSIFIER_ROLE:
			return getClassifierRole();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__COLLABORATION:
			return getCollaboration();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__COLLABORATION_INSTANCE_SET:
			return getCollaborationInstanceSet();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__PARTITION:
			return getPartition();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__ELEMENT_IMPORT:
			return getElementImport();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__CONTEXT:
			return getContext();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__INTERACTION:
			if (resolve)
				return getInteraction();
			return basicGetInteraction();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__PARTICIPATING_STIMULUS:
			return getParticipatingStimulus();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__NAME:
			setName((String) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__VISIBILITY:
			setVisibility((VisibilityKind) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			getDefaultedParameter().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__STEREOTYPE:
			getStereotype().clear();
			getStereotype().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__REFERENCE_TAG:
			getReferenceTag().clear();
			getReferenceTag().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			getTemplateArgument().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			getCollaborationInstanceSet().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__CONTEXT:
			setContext((CollaborationInstanceSet) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__INTERACTION:
			setInteraction((Interaction) newValue);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__PARTICIPATING_STIMULUS:
			getParticipatingStimulus().clear();
			getParticipatingStimulus().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__NAME:
			setName(NAME_EDEFAULT);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__CONSTRAINT:
			getConstraint().clear();
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__PRESENTATION:
			getPresentation().clear();
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__COMMENT:
			getComment().clear();
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) null);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__STEREOTYPE:
			getStereotype().clear();
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__REFERENCE_TAG:
			getReferenceTag().clear();
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__BEHAVIOR:
			getBehavior().clear();
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__COLLABORATION:
			getCollaboration().clear();
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__PARTITION:
			getPartition().clear();
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__CONTEXT:
			setContext((CollaborationInstanceSet) null);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__INTERACTION:
			setInteraction((Interaction) null);
			return;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__PARTICIPATING_STIMULUS:
			getParticipatingStimulus().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__VISIBILITY:
			return visibility != VISIBILITY_EDEFAULT;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__NAMESPACE:
			return getNamespace() != null;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__DEFAULTED_PARAMETER:
			return defaultedParameter != null && !defaultedParameter.isEmpty();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__COMMENT:
			return comment != null && !comment.isEmpty();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__PARAMETER_TEMPLATE:
			return getParameterTemplate() != null;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__STEREOTYPE:
			return stereotype != null && !stereotype.isEmpty();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__REFERENCE_TAG:
			return referenceTag != null && !referenceTag.isEmpty();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__TEMPLATE_ARGUMENT:
			return templateArgument != null && !templateArgument.isEmpty();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__COLLABORATION_INSTANCE_SET:
			return collaborationInstanceSet != null && !collaborationInstanceSet.isEmpty();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__PARTITION:
			return partition != null && !partition.isEmpty();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__CONTEXT:
			return getContext() != null;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__INTERACTION:
			return interaction != null;
		case CollaborationsPackage.INTERACTION_INSTANCE_SET__PARTICIPATING_STIMULUS:
			return participatingStimulus != null && !participatingStimulus.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

} // InteractionInstanceSetImpl
