/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.foundation.core.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EObject;

import fr.obeo.acceleo.uml14.foundation.core.Abstraction;
import fr.obeo.acceleo.uml14.foundation.core.Artifact;
import fr.obeo.acceleo.uml14.foundation.core.Association;
import fr.obeo.acceleo.uml14.foundation.core.AssociationClass;
import fr.obeo.acceleo.uml14.foundation.core.AssociationEnd;
import fr.obeo.acceleo.uml14.foundation.core.Attribute;
import fr.obeo.acceleo.uml14.foundation.core.BehavioralFeature;
import fr.obeo.acceleo.uml14.foundation.core.Binding;
import fr.obeo.acceleo.uml14.foundation.core.Classifier;
import fr.obeo.acceleo.uml14.foundation.core.Comment;
import fr.obeo.acceleo.uml14.foundation.core.Component;
import fr.obeo.acceleo.uml14.foundation.core.Constraint;
import fr.obeo.acceleo.uml14.foundation.core.CorePackage;
import fr.obeo.acceleo.uml14.foundation.core.DataType;
import fr.obeo.acceleo.uml14.foundation.core.Dependency;
import fr.obeo.acceleo.uml14.foundation.core.Element;
import fr.obeo.acceleo.uml14.foundation.core.ElementResidence;
import fr.obeo.acceleo.uml14.foundation.core.Enumeration;
import fr.obeo.acceleo.uml14.foundation.core.EnumerationLiteral;
import fr.obeo.acceleo.uml14.foundation.core.Feature;
import fr.obeo.acceleo.uml14.foundation.core.Flow;
import fr.obeo.acceleo.uml14.foundation.core.GeneralizableElement;
import fr.obeo.acceleo.uml14.foundation.core.Generalization;
import fr.obeo.acceleo.uml14.foundation.core.Interface;
import fr.obeo.acceleo.uml14.foundation.core.Method;
import fr.obeo.acceleo.uml14.foundation.core.ModelElement;
import fr.obeo.acceleo.uml14.foundation.core.Namespace;
import fr.obeo.acceleo.uml14.foundation.core.Node;
import fr.obeo.acceleo.uml14.foundation.core.Operation;
import fr.obeo.acceleo.uml14.foundation.core.Parameter;
import fr.obeo.acceleo.uml14.foundation.core.Permission;
import fr.obeo.acceleo.uml14.foundation.core.PresentationElement;
import fr.obeo.acceleo.uml14.foundation.core.Primitive;
import fr.obeo.acceleo.uml14.foundation.core.ProgrammingLanguageDataType;
import fr.obeo.acceleo.uml14.foundation.core.Relationship;
import fr.obeo.acceleo.uml14.foundation.core.Stereotype;
import fr.obeo.acceleo.uml14.foundation.core.StructuralFeature;
import fr.obeo.acceleo.uml14.foundation.core.TagDefinition;
import fr.obeo.acceleo.uml14.foundation.core.TaggedValue;
import fr.obeo.acceleo.uml14.foundation.core.TemplateArgument;
import fr.obeo.acceleo.uml14.foundation.core.TemplateParameter;
import fr.obeo.acceleo.uml14.foundation.core.Usage;

/**
 * <!-- begin-user-doc --> The <b>Adapter Factory</b> for the model. It provides
 * an adapter <code>createXXX</code> method for each class of the model. <!--
 * end-user-doc -->
 * 
 * @see fr.obeo.acceleo.uml14.foundation.core.CorePackage
 * @generated
 */
public class CoreAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected static CorePackage modelPackage;

	/**
	 * Creates an instance of the adapter factory. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public CoreAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = CorePackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc --> This implementation returns <code>true</code> if
	 * the object is either the model's package or is an instance object of the
	 * model. <!-- end-user-doc -->
	 * 
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject) object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch the delegates to the <code>createXXX</code> methods. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected CoreSwitch modelSwitch = new CoreSwitch() {
		public Object caseElement(Element object) {
			return createElementAdapter();
		}

		public Object caseModelElement(ModelElement object) {
			return createModelElementAdapter();
		}

		public Object caseGeneralizableElement(GeneralizableElement object) {
			return createGeneralizableElementAdapter();
		}

		public Object caseNamespace(Namespace object) {
			return createNamespaceAdapter();
		}

		public Object caseClassifier(Classifier object) {
			return createClassifierAdapter();
		}

		public Object caseClass(fr.obeo.acceleo.uml14.foundation.core.Class object) {
			return createClassAdapter();
		}

		public Object caseDataType(DataType object) {
			return createDataTypeAdapter();
		}

		public Object caseFeature(Feature object) {
			return createFeatureAdapter();
		}

		public Object caseStructuralFeature(StructuralFeature object) {
			return createStructuralFeatureAdapter();
		}

		public Object caseAssociationEnd(AssociationEnd object) {
			return createAssociationEndAdapter();
		}

		public Object caseInterface(Interface object) {
			return createInterfaceAdapter();
		}

		public Object caseConstraint(Constraint object) {
			return createConstraintAdapter();
		}

		public Object caseRelationship(Relationship object) {
			return createRelationshipAdapter();
		}

		public Object caseAssociation(Association object) {
			return createAssociationAdapter();
		}

		public Object caseAttribute(Attribute object) {
			return createAttributeAdapter();
		}

		public Object caseBehavioralFeature(BehavioralFeature object) {
			return createBehavioralFeatureAdapter();
		}

		public Object caseOperation(Operation object) {
			return createOperationAdapter();
		}

		public Object caseParameter(Parameter object) {
			return createParameterAdapter();
		}

		public Object caseMethod(Method object) {
			return createMethodAdapter();
		}

		public Object caseGeneralization(Generalization object) {
			return createGeneralizationAdapter();
		}

		public Object caseAssociationClass(AssociationClass object) {
			return createAssociationClassAdapter();
		}

		public Object caseDependency(Dependency object) {
			return createDependencyAdapter();
		}

		public Object caseAbstraction(Abstraction object) {
			return createAbstractionAdapter();
		}

		public Object casePresentationElement(PresentationElement object) {
			return createPresentationElementAdapter();
		}

		public Object caseUsage(Usage object) {
			return createUsageAdapter();
		}

		public Object caseBinding(Binding object) {
			return createBindingAdapter();
		}

		public Object caseComponent(Component object) {
			return createComponentAdapter();
		}

		public Object caseNode(Node object) {
			return createNodeAdapter();
		}

		public Object casePermission(Permission object) {
			return createPermissionAdapter();
		}

		public Object caseComment(Comment object) {
			return createCommentAdapter();
		}

		public Object caseFlow(Flow object) {
			return createFlowAdapter();
		}

		public Object caseElementResidence(ElementResidence object) {
			return createElementResidenceAdapter();
		}

		public Object caseTemplateParameter(TemplateParameter object) {
			return createTemplateParameterAdapter();
		}

		public Object casePrimitive(Primitive object) {
			return createPrimitiveAdapter();
		}

		public Object caseEnumeration(Enumeration object) {
			return createEnumerationAdapter();
		}

		public Object caseEnumerationLiteral(EnumerationLiteral object) {
			return createEnumerationLiteralAdapter();
		}

		public Object caseStereotype(Stereotype object) {
			return createStereotypeAdapter();
		}

		public Object caseTagDefinition(TagDefinition object) {
			return createTagDefinitionAdapter();
		}

		public Object caseTaggedValue(TaggedValue object) {
			return createTaggedValueAdapter();
		}

		public Object caseProgrammingLanguageDataType(ProgrammingLanguageDataType object) {
			return createProgrammingLanguageDataTypeAdapter();
		}

		public Object caseArtifact(Artifact object) {
			return createArtifactAdapter();
		}

		public Object caseTemplateArgument(TemplateArgument object) {
			return createTemplateArgumentAdapter();
		}

		public Object defaultCase(EObject object) {
			return createEObjectAdapter();
		}
	};

	/**
	 * Creates an adapter for the <code>target</code>. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @param target
	 *            the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	public Adapter createAdapter(Notifier target) {
		return (Adapter) modelSwitch.doSwitch((EObject) target);
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Element <em>Element</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Element
	 * @generated
	 */
	public Adapter createElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.ModelElement
	 * <em>Model Element</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.ModelElement
	 * @generated
	 */
	public Adapter createModelElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.GeneralizableElement
	 * <em>Generalizable Element</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.GeneralizableElement
	 * @generated
	 */
	public Adapter createGeneralizableElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Namespace
	 * <em>Namespace</em>}'. <!-- begin-user-doc --> This default implementation
	 * returns null so that we can easily ignore cases; it's useful to ignore a
	 * case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Namespace
	 * @generated
	 */
	public Adapter createNamespaceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Classifier
	 * <em>Classifier</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Classifier
	 * @generated
	 */
	public Adapter createClassifierAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Class <em>Class</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Class
	 * @generated
	 */
	public Adapter createClassAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.DataType <em>Data Type</em>}
	 * '. <!-- begin-user-doc --> This default implementation returns null so
	 * that we can easily ignore cases; it's useful to ignore a case when
	 * inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.DataType
	 * @generated
	 */
	public Adapter createDataTypeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Feature <em>Feature</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Feature
	 * @generated
	 */
	public Adapter createFeatureAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.StructuralFeature
	 * <em>Structural Feature</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.StructuralFeature
	 * @generated
	 */
	public Adapter createStructuralFeatureAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.AssociationEnd
	 * <em>Association End</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.AssociationEnd
	 * @generated
	 */
	public Adapter createAssociationEndAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Interface
	 * <em>Interface</em>}'. <!-- begin-user-doc --> This default implementation
	 * returns null so that we can easily ignore cases; it's useful to ignore a
	 * case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Interface
	 * @generated
	 */
	public Adapter createInterfaceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Constraint
	 * <em>Constraint</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Constraint
	 * @generated
	 */
	public Adapter createConstraintAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Relationship
	 * <em>Relationship</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Relationship
	 * @generated
	 */
	public Adapter createRelationshipAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Association
	 * <em>Association</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Association
	 * @generated
	 */
	public Adapter createAssociationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Attribute
	 * <em>Attribute</em>}'. <!-- begin-user-doc --> This default implementation
	 * returns null so that we can easily ignore cases; it's useful to ignore a
	 * case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Attribute
	 * @generated
	 */
	public Adapter createAttributeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.BehavioralFeature
	 * <em>Behavioral Feature</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.BehavioralFeature
	 * @generated
	 */
	public Adapter createBehavioralFeatureAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Operation
	 * <em>Operation</em>}'. <!-- begin-user-doc --> This default implementation
	 * returns null so that we can easily ignore cases; it's useful to ignore a
	 * case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Operation
	 * @generated
	 */
	public Adapter createOperationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Parameter
	 * <em>Parameter</em>}'. <!-- begin-user-doc --> This default implementation
	 * returns null so that we can easily ignore cases; it's useful to ignore a
	 * case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Parameter
	 * @generated
	 */
	public Adapter createParameterAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Method <em>Method</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Method
	 * @generated
	 */
	public Adapter createMethodAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Generalization
	 * <em>Generalization</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Generalization
	 * @generated
	 */
	public Adapter createGeneralizationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.AssociationClass
	 * <em>Association Class</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.AssociationClass
	 * @generated
	 */
	public Adapter createAssociationClassAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Dependency
	 * <em>Dependency</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Dependency
	 * @generated
	 */
	public Adapter createDependencyAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Abstraction
	 * <em>Abstraction</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Abstraction
	 * @generated
	 */
	public Adapter createAbstractionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.PresentationElement
	 * <em>Presentation Element</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.PresentationElement
	 * @generated
	 */
	public Adapter createPresentationElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Usage <em>Usage</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Usage
	 * @generated
	 */
	public Adapter createUsageAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Binding <em>Binding</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Binding
	 * @generated
	 */
	public Adapter createBindingAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Component
	 * <em>Component</em>}'. <!-- begin-user-doc --> This default implementation
	 * returns null so that we can easily ignore cases; it's useful to ignore a
	 * case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Component
	 * @generated
	 */
	public Adapter createComponentAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Node <em>Node</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Node
	 * @generated
	 */
	public Adapter createNodeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Permission
	 * <em>Permission</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Permission
	 * @generated
	 */
	public Adapter createPermissionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Comment <em>Comment</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Comment
	 * @generated
	 */
	public Adapter createCommentAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Flow <em>Flow</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Flow
	 * @generated
	 */
	public Adapter createFlowAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.ElementResidence
	 * <em>Element Residence</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.ElementResidence
	 * @generated
	 */
	public Adapter createElementResidenceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.TemplateParameter
	 * <em>Template Parameter</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.TemplateParameter
	 * @generated
	 */
	public Adapter createTemplateParameterAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Primitive
	 * <em>Primitive</em>}'. <!-- begin-user-doc --> This default implementation
	 * returns null so that we can easily ignore cases; it's useful to ignore a
	 * case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Primitive
	 * @generated
	 */
	public Adapter createPrimitiveAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Enumeration
	 * <em>Enumeration</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Enumeration
	 * @generated
	 */
	public Adapter createEnumerationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.EnumerationLiteral
	 * <em>Enumeration Literal</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.EnumerationLiteral
	 * @generated
	 */
	public Adapter createEnumerationLiteralAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Stereotype
	 * <em>Stereotype</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Stereotype
	 * @generated
	 */
	public Adapter createStereotypeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.TagDefinition
	 * <em>Tag Definition</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.TagDefinition
	 * @generated
	 */
	public Adapter createTagDefinitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.TaggedValue
	 * <em>Tagged Value</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.TaggedValue
	 * @generated
	 */
	public Adapter createTaggedValueAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.ProgrammingLanguageDataType
	 * <em>Programming Language Data Type</em>}'. <!-- begin-user-doc --> This
	 * default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases
	 * anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.ProgrammingLanguageDataType
	 * @generated
	 */
	public Adapter createProgrammingLanguageDataTypeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.Artifact <em>Artifact</em>}
	 * '. <!-- begin-user-doc --> This default implementation returns null so
	 * that we can easily ignore cases; it's useful to ignore a case when
	 * inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Artifact
	 * @generated
	 */
	public Adapter createArtifactAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.TemplateArgument
	 * <em>Template Argument</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.TemplateArgument
	 * @generated
	 */
	public Adapter createTemplateArgumentAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case. <!-- begin-user-doc --> This
	 * default implementation returns null. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} // CoreAdapterFactory
