/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.foundation.core.util;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import fr.obeo.acceleo.uml14.foundation.core.Abstraction;
import fr.obeo.acceleo.uml14.foundation.core.Artifact;
import fr.obeo.acceleo.uml14.foundation.core.Association;
import fr.obeo.acceleo.uml14.foundation.core.AssociationClass;
import fr.obeo.acceleo.uml14.foundation.core.AssociationEnd;
import fr.obeo.acceleo.uml14.foundation.core.Attribute;
import fr.obeo.acceleo.uml14.foundation.core.BehavioralFeature;
import fr.obeo.acceleo.uml14.foundation.core.Binding;
import fr.obeo.acceleo.uml14.foundation.core.Classifier;
import fr.obeo.acceleo.uml14.foundation.core.Comment;
import fr.obeo.acceleo.uml14.foundation.core.Component;
import fr.obeo.acceleo.uml14.foundation.core.Constraint;
import fr.obeo.acceleo.uml14.foundation.core.CorePackage;
import fr.obeo.acceleo.uml14.foundation.core.DataType;
import fr.obeo.acceleo.uml14.foundation.core.Dependency;
import fr.obeo.acceleo.uml14.foundation.core.Element;
import fr.obeo.acceleo.uml14.foundation.core.ElementResidence;
import fr.obeo.acceleo.uml14.foundation.core.Enumeration;
import fr.obeo.acceleo.uml14.foundation.core.EnumerationLiteral;
import fr.obeo.acceleo.uml14.foundation.core.Feature;
import fr.obeo.acceleo.uml14.foundation.core.Flow;
import fr.obeo.acceleo.uml14.foundation.core.GeneralizableElement;
import fr.obeo.acceleo.uml14.foundation.core.Generalization;
import fr.obeo.acceleo.uml14.foundation.core.Interface;
import fr.obeo.acceleo.uml14.foundation.core.Method;
import fr.obeo.acceleo.uml14.foundation.core.ModelElement;
import fr.obeo.acceleo.uml14.foundation.core.Namespace;
import fr.obeo.acceleo.uml14.foundation.core.Node;
import fr.obeo.acceleo.uml14.foundation.core.Operation;
import fr.obeo.acceleo.uml14.foundation.core.Parameter;
import fr.obeo.acceleo.uml14.foundation.core.Permission;
import fr.obeo.acceleo.uml14.foundation.core.PresentationElement;
import fr.obeo.acceleo.uml14.foundation.core.Primitive;
import fr.obeo.acceleo.uml14.foundation.core.ProgrammingLanguageDataType;
import fr.obeo.acceleo.uml14.foundation.core.Relationship;
import fr.obeo.acceleo.uml14.foundation.core.Stereotype;
import fr.obeo.acceleo.uml14.foundation.core.StructuralFeature;
import fr.obeo.acceleo.uml14.foundation.core.TagDefinition;
import fr.obeo.acceleo.uml14.foundation.core.TaggedValue;
import fr.obeo.acceleo.uml14.foundation.core.TemplateArgument;
import fr.obeo.acceleo.uml14.foundation.core.TemplateParameter;
import fr.obeo.acceleo.uml14.foundation.core.Usage;

/**
 * <!-- begin-user-doc --> The <b>Switch</b> for the model's inheritance
 * hierarchy. It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object and proceeding up the
 * inheritance hierarchy until a non-null result is returned, which is the
 * result of the switch. <!-- end-user-doc -->
 * 
 * @see fr.obeo.acceleo.uml14.foundation.core.CorePackage
 * @generated
 */
public class CoreSwitch {
	/**
	 * The cached model package <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected static CorePackage modelPackage;

	/**
	 * Creates an instance of the switch. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public CoreSwitch() {
		if (modelPackage == null) {
			modelPackage = CorePackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns
	 * a non null result; it yields that result. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the first non-null result returned by a <code>caseXXX</code>
	 *         call.
	 * @generated
	 */
	public Object doSwitch(EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns
	 * a non null result; it yields that result. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the first non-null result returned by a <code>caseXXX</code>
	 *         call.
	 * @generated
	 */
	protected Object doSwitch(EClass theEClass, EObject theEObject) {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		} else {
			List eSuperTypes = theEClass.getESuperTypes();
			return eSuperTypes.isEmpty() ? defaultCase(theEObject) : doSwitch((EClass) eSuperTypes.get(0), theEObject);
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns
	 * a non null result; it yields that result. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the first non-null result returned by a <code>caseXXX</code>
	 *         call.
	 * @generated
	 */
	protected Object doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
		case CorePackage.ELEMENT: {
			Element element = (Element) theEObject;
			Object result = caseElement(element);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.MODEL_ELEMENT: {
			ModelElement modelElement = (ModelElement) theEObject;
			Object result = caseModelElement(modelElement);
			if (result == null)
				result = caseElement(modelElement);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.GENERALIZABLE_ELEMENT: {
			GeneralizableElement generalizableElement = (GeneralizableElement) theEObject;
			Object result = caseGeneralizableElement(generalizableElement);
			if (result == null)
				result = caseModelElement(generalizableElement);
			if (result == null)
				result = caseElement(generalizableElement);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.NAMESPACE: {
			Namespace namespace = (Namespace) theEObject;
			Object result = caseNamespace(namespace);
			if (result == null)
				result = caseModelElement(namespace);
			if (result == null)
				result = caseElement(namespace);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.CLASSIFIER: {
			Classifier classifier = (Classifier) theEObject;
			Object result = caseClassifier(classifier);
			if (result == null)
				result = caseGeneralizableElement(classifier);
			if (result == null)
				result = caseNamespace(classifier);
			if (result == null)
				result = caseModelElement(classifier);
			if (result == null)
				result = caseElement(classifier);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.CLASS: {
			fr.obeo.acceleo.uml14.foundation.core.Class class_ = (fr.obeo.acceleo.uml14.foundation.core.Class) theEObject;
			Object result = caseClass(class_);
			if (result == null)
				result = caseClassifier(class_);
			if (result == null)
				result = caseGeneralizableElement(class_);
			if (result == null)
				result = caseNamespace(class_);
			if (result == null)
				result = caseModelElement(class_);
			if (result == null)
				result = caseElement(class_);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.DATA_TYPE: {
			DataType dataType = (DataType) theEObject;
			Object result = caseDataType(dataType);
			if (result == null)
				result = caseClassifier(dataType);
			if (result == null)
				result = caseGeneralizableElement(dataType);
			if (result == null)
				result = caseNamespace(dataType);
			if (result == null)
				result = caseModelElement(dataType);
			if (result == null)
				result = caseElement(dataType);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.FEATURE: {
			Feature feature = (Feature) theEObject;
			Object result = caseFeature(feature);
			if (result == null)
				result = caseModelElement(feature);
			if (result == null)
				result = caseElement(feature);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.STRUCTURAL_FEATURE: {
			StructuralFeature structuralFeature = (StructuralFeature) theEObject;
			Object result = caseStructuralFeature(structuralFeature);
			if (result == null)
				result = caseFeature(structuralFeature);
			if (result == null)
				result = caseModelElement(structuralFeature);
			if (result == null)
				result = caseElement(structuralFeature);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.ASSOCIATION_END: {
			AssociationEnd associationEnd = (AssociationEnd) theEObject;
			Object result = caseAssociationEnd(associationEnd);
			if (result == null)
				result = caseModelElement(associationEnd);
			if (result == null)
				result = caseElement(associationEnd);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.INTERFACE: {
			Interface interface_ = (Interface) theEObject;
			Object result = caseInterface(interface_);
			if (result == null)
				result = caseClassifier(interface_);
			if (result == null)
				result = caseGeneralizableElement(interface_);
			if (result == null)
				result = caseNamespace(interface_);
			if (result == null)
				result = caseModelElement(interface_);
			if (result == null)
				result = caseElement(interface_);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.CONSTRAINT: {
			Constraint constraint = (Constraint) theEObject;
			Object result = caseConstraint(constraint);
			if (result == null)
				result = caseModelElement(constraint);
			if (result == null)
				result = caseElement(constraint);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.RELATIONSHIP: {
			Relationship relationship = (Relationship) theEObject;
			Object result = caseRelationship(relationship);
			if (result == null)
				result = caseModelElement(relationship);
			if (result == null)
				result = caseElement(relationship);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.ASSOCIATION: {
			Association association = (Association) theEObject;
			Object result = caseAssociation(association);
			if (result == null)
				result = caseGeneralizableElement(association);
			if (result == null)
				result = caseRelationship(association);
			if (result == null)
				result = caseModelElement(association);
			if (result == null)
				result = caseElement(association);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.ATTRIBUTE: {
			Attribute attribute = (Attribute) theEObject;
			Object result = caseAttribute(attribute);
			if (result == null)
				result = caseStructuralFeature(attribute);
			if (result == null)
				result = caseFeature(attribute);
			if (result == null)
				result = caseModelElement(attribute);
			if (result == null)
				result = caseElement(attribute);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.BEHAVIORAL_FEATURE: {
			BehavioralFeature behavioralFeature = (BehavioralFeature) theEObject;
			Object result = caseBehavioralFeature(behavioralFeature);
			if (result == null)
				result = caseFeature(behavioralFeature);
			if (result == null)
				result = caseModelElement(behavioralFeature);
			if (result == null)
				result = caseElement(behavioralFeature);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.OPERATION: {
			Operation operation = (Operation) theEObject;
			Object result = caseOperation(operation);
			if (result == null)
				result = caseBehavioralFeature(operation);
			if (result == null)
				result = caseFeature(operation);
			if (result == null)
				result = caseModelElement(operation);
			if (result == null)
				result = caseElement(operation);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.PARAMETER: {
			Parameter parameter = (Parameter) theEObject;
			Object result = caseParameter(parameter);
			if (result == null)
				result = caseModelElement(parameter);
			if (result == null)
				result = caseElement(parameter);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.METHOD: {
			Method method = (Method) theEObject;
			Object result = caseMethod(method);
			if (result == null)
				result = caseBehavioralFeature(method);
			if (result == null)
				result = caseFeature(method);
			if (result == null)
				result = caseModelElement(method);
			if (result == null)
				result = caseElement(method);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.GENERALIZATION: {
			Generalization generalization = (Generalization) theEObject;
			Object result = caseGeneralization(generalization);
			if (result == null)
				result = caseRelationship(generalization);
			if (result == null)
				result = caseModelElement(generalization);
			if (result == null)
				result = caseElement(generalization);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.ASSOCIATION_CLASS: {
			AssociationClass associationClass = (AssociationClass) theEObject;
			Object result = caseAssociationClass(associationClass);
			if (result == null)
				result = caseClass(associationClass);
			if (result == null)
				result = caseAssociation(associationClass);
			if (result == null)
				result = caseClassifier(associationClass);
			if (result == null)
				result = caseGeneralizableElement(associationClass);
			if (result == null)
				result = caseRelationship(associationClass);
			if (result == null)
				result = caseNamespace(associationClass);
			if (result == null)
				result = caseModelElement(associationClass);
			if (result == null)
				result = caseElement(associationClass);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.DEPENDENCY: {
			Dependency dependency = (Dependency) theEObject;
			Object result = caseDependency(dependency);
			if (result == null)
				result = caseRelationship(dependency);
			if (result == null)
				result = caseModelElement(dependency);
			if (result == null)
				result = caseElement(dependency);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.ABSTRACTION: {
			Abstraction abstraction = (Abstraction) theEObject;
			Object result = caseAbstraction(abstraction);
			if (result == null)
				result = caseDependency(abstraction);
			if (result == null)
				result = caseRelationship(abstraction);
			if (result == null)
				result = caseModelElement(abstraction);
			if (result == null)
				result = caseElement(abstraction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.PRESENTATION_ELEMENT: {
			PresentationElement presentationElement = (PresentationElement) theEObject;
			Object result = casePresentationElement(presentationElement);
			if (result == null)
				result = caseElement(presentationElement);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.USAGE: {
			Usage usage = (Usage) theEObject;
			Object result = caseUsage(usage);
			if (result == null)
				result = caseDependency(usage);
			if (result == null)
				result = caseRelationship(usage);
			if (result == null)
				result = caseModelElement(usage);
			if (result == null)
				result = caseElement(usage);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.BINDING: {
			Binding binding = (Binding) theEObject;
			Object result = caseBinding(binding);
			if (result == null)
				result = caseDependency(binding);
			if (result == null)
				result = caseRelationship(binding);
			if (result == null)
				result = caseModelElement(binding);
			if (result == null)
				result = caseElement(binding);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.COMPONENT: {
			Component component = (Component) theEObject;
			Object result = caseComponent(component);
			if (result == null)
				result = caseClassifier(component);
			if (result == null)
				result = caseGeneralizableElement(component);
			if (result == null)
				result = caseNamespace(component);
			if (result == null)
				result = caseModelElement(component);
			if (result == null)
				result = caseElement(component);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.NODE: {
			Node node = (Node) theEObject;
			Object result = caseNode(node);
			if (result == null)
				result = caseClassifier(node);
			if (result == null)
				result = caseGeneralizableElement(node);
			if (result == null)
				result = caseNamespace(node);
			if (result == null)
				result = caseModelElement(node);
			if (result == null)
				result = caseElement(node);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.PERMISSION: {
			Permission permission = (Permission) theEObject;
			Object result = casePermission(permission);
			if (result == null)
				result = caseDependency(permission);
			if (result == null)
				result = caseRelationship(permission);
			if (result == null)
				result = caseModelElement(permission);
			if (result == null)
				result = caseElement(permission);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.COMMENT: {
			Comment comment = (Comment) theEObject;
			Object result = caseComment(comment);
			if (result == null)
				result = caseModelElement(comment);
			if (result == null)
				result = caseElement(comment);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.FLOW: {
			Flow flow = (Flow) theEObject;
			Object result = caseFlow(flow);
			if (result == null)
				result = caseRelationship(flow);
			if (result == null)
				result = caseModelElement(flow);
			if (result == null)
				result = caseElement(flow);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.ELEMENT_RESIDENCE: {
			ElementResidence elementResidence = (ElementResidence) theEObject;
			Object result = caseElementResidence(elementResidence);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.TEMPLATE_PARAMETER: {
			TemplateParameter templateParameter = (TemplateParameter) theEObject;
			Object result = caseTemplateParameter(templateParameter);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.PRIMITIVE: {
			Primitive primitive = (Primitive) theEObject;
			Object result = casePrimitive(primitive);
			if (result == null)
				result = caseDataType(primitive);
			if (result == null)
				result = caseClassifier(primitive);
			if (result == null)
				result = caseGeneralizableElement(primitive);
			if (result == null)
				result = caseNamespace(primitive);
			if (result == null)
				result = caseModelElement(primitive);
			if (result == null)
				result = caseElement(primitive);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.ENUMERATION: {
			Enumeration enumeration = (Enumeration) theEObject;
			Object result = caseEnumeration(enumeration);
			if (result == null)
				result = caseDataType(enumeration);
			if (result == null)
				result = caseClassifier(enumeration);
			if (result == null)
				result = caseGeneralizableElement(enumeration);
			if (result == null)
				result = caseNamespace(enumeration);
			if (result == null)
				result = caseModelElement(enumeration);
			if (result == null)
				result = caseElement(enumeration);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.ENUMERATION_LITERAL: {
			EnumerationLiteral enumerationLiteral = (EnumerationLiteral) theEObject;
			Object result = caseEnumerationLiteral(enumerationLiteral);
			if (result == null)
				result = caseModelElement(enumerationLiteral);
			if (result == null)
				result = caseElement(enumerationLiteral);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.STEREOTYPE: {
			Stereotype stereotype = (Stereotype) theEObject;
			Object result = caseStereotype(stereotype);
			if (result == null)
				result = caseGeneralizableElement(stereotype);
			if (result == null)
				result = caseModelElement(stereotype);
			if (result == null)
				result = caseElement(stereotype);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.TAG_DEFINITION: {
			TagDefinition tagDefinition = (TagDefinition) theEObject;
			Object result = caseTagDefinition(tagDefinition);
			if (result == null)
				result = caseModelElement(tagDefinition);
			if (result == null)
				result = caseElement(tagDefinition);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.TAGGED_VALUE: {
			TaggedValue taggedValue = (TaggedValue) theEObject;
			Object result = caseTaggedValue(taggedValue);
			if (result == null)
				result = caseModelElement(taggedValue);
			if (result == null)
				result = caseElement(taggedValue);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.PROGRAMMING_LANGUAGE_DATA_TYPE: {
			ProgrammingLanguageDataType programmingLanguageDataType = (ProgrammingLanguageDataType) theEObject;
			Object result = caseProgrammingLanguageDataType(programmingLanguageDataType);
			if (result == null)
				result = caseDataType(programmingLanguageDataType);
			if (result == null)
				result = caseClassifier(programmingLanguageDataType);
			if (result == null)
				result = caseGeneralizableElement(programmingLanguageDataType);
			if (result == null)
				result = caseNamespace(programmingLanguageDataType);
			if (result == null)
				result = caseModelElement(programmingLanguageDataType);
			if (result == null)
				result = caseElement(programmingLanguageDataType);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.ARTIFACT: {
			Artifact artifact = (Artifact) theEObject;
			Object result = caseArtifact(artifact);
			if (result == null)
				result = caseClassifier(artifact);
			if (result == null)
				result = caseGeneralizableElement(artifact);
			if (result == null)
				result = caseNamespace(artifact);
			if (result == null)
				result = caseModelElement(artifact);
			if (result == null)
				result = caseElement(artifact);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case CorePackage.TEMPLATE_ARGUMENT: {
			TemplateArgument templateArgument = (TemplateArgument) theEObject;
			Object result = caseTemplateArgument(templateArgument);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		default:
			return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Element</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseElement(Element object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Model Element</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Model Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseModelElement(ModelElement object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Generalizable Element</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Generalizable Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseGeneralizableElement(GeneralizableElement object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Namespace</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Namespace</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseNamespace(Namespace object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Classifier</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Classifier</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseClassifier(Classifier object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Class</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Class</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseClass(fr.obeo.acceleo.uml14.foundation.core.Class object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Data Type</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Data Type</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseDataType(DataType object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Feature</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Feature</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseFeature(Feature object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Structural Feature</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Structural Feature</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseStructuralFeature(StructuralFeature object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Association End</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Association End</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseAssociationEnd(AssociationEnd object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Interface</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Interface</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseInterface(Interface object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Constraint</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Constraint</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseConstraint(Constraint object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Relationship</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Relationship</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseRelationship(Relationship object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Association</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Association</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseAssociation(Association object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Attribute</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Attribute</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseAttribute(Attribute object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Behavioral Feature</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Behavioral Feature</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseBehavioralFeature(BehavioralFeature object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Operation</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Operation</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseOperation(Operation object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Parameter</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Parameter</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseParameter(Parameter object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Method</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Method</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseMethod(Method object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Generalization</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Generalization</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseGeneralization(Generalization object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Association Class</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Association Class</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseAssociationClass(AssociationClass object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Dependency</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Dependency</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseDependency(Dependency object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Abstraction</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Abstraction</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseAbstraction(Abstraction object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Presentation Element</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Presentation Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object casePresentationElement(PresentationElement object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Usage</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Usage</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseUsage(Usage object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Binding</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Binding</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseBinding(Binding object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Component</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Component</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseComponent(Component object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Node</em>'. <!-- begin-user-doc --> This implementation returns null;
	 * returning a non-null result will terminate the switch. <!-- end-user-doc
	 * -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseNode(Node object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Permission</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Permission</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object casePermission(Permission object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Comment</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Comment</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseComment(Comment object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Flow</em>'. <!-- begin-user-doc --> This implementation returns null;
	 * returning a non-null result will terminate the switch. <!-- end-user-doc
	 * -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Flow</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseFlow(Flow object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Element Residence</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Element Residence</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseElementResidence(ElementResidence object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Template Parameter</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Template Parameter</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseTemplateParameter(TemplateParameter object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Primitive</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Primitive</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object casePrimitive(Primitive object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Enumeration</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Enumeration</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseEnumeration(Enumeration object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Enumeration Literal</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Enumeration Literal</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseEnumerationLiteral(EnumerationLiteral object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Stereotype</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Stereotype</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseStereotype(Stereotype object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Tag Definition</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Tag Definition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseTagDefinition(TagDefinition object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Tagged Value</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Tagged Value</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseTaggedValue(TaggedValue object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Programming Language Data Type</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Programming Language Data Type</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseProgrammingLanguageDataType(ProgrammingLanguageDataType object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Artifact</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Artifact</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseArtifact(Artifact object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Template Argument</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Template Argument</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseTemplateArgument(TemplateArgument object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>EObject</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch, but this is
	 * the last case anyway. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public Object defaultCase(EObject object) {
		return null;
	}

} // CoreSwitch
